

/* Example sketch to control a 28BYJ-48 stepper motor with ULN2003 driver board, AccelStepper and Arduino UNO: number of steps/revolutions. More info: https://www.makerguides.com 
v4 added presure extreme LEDs
v5 add forcast LEDs and calc
v6 sorted enable and sleep order
v7 remove adjust on and test replace it with Clearing and threatening LEDs PIN 12 and 13 
v8 add dac driver-deleted
v9 added LCD
v10 added weather forecast usingLEDs 
v12 LEds test added
v13 add 1 dp point to 3 hour display
v14 void 1026 add slow set buttons
v18 voided 
v19last reading not included in number of steps
v20 change led test order
v20a serial.print removed indicated by // serial removed
v21 as 20a identical to v20 that includes serial print
v22 High/Low LEDs will light before on reciept of 1 hour pulse to show when 3 hour dial will update
v23 Moved LED control to Loop
v27 bug corrected (thanks Artur Bialeta) void  maninchFwd() changed stepper.setSpeed(-10); to stepper.setSpeed(10);

version number @ line 196
*/
#include <SFE_BMP180.h> //SFE_BMP180 pressure sensor
#include <SPI.h>
#include <LiquidCrystal_I2C.h>


// ######## You will need to create an SFE_BMP180 object, here called "pressure":

SFE_BMP180 pressure;

#define ALTITUDE 125.0 // Altitude of Kenley Surrey in meters

//#########

//**********************
// set the LCD address to 0x27 for a 20 chars 4 line display
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address

//#define DS3231_I2C_ADDRESS 0x68
// Convert normal decimal numbers to binary coded decimal
byte decToBcd(byte val)
{
  return( (val/10*16) + (val%10) );
}
// Convert binary coded decimal to normal decimal numbers
byte bcdToDec(byte val)
{
  return( (val/16*10) + (val%16) );
}


// Include the AccelStepper library:
#include <AccelStepper.h>

// Define stepper motor connections and motor interface type. Motor interface type must be set to 1 when using a driver:
#define dirPin 11
#define stepPin 10


#define motorInterfaceType 1
// Create a new instance of the AccelStepper class:
AccelStepper stepper = AccelStepper(motorInterfaceType, stepPin, dirPin);



float seaPressure = 0;
float pressureNow = 0;
float pressurePrevious = 0;
float pressureDiff = 0;
int checkStop = 0;
//int pressureRndDiff = 0;
int pressureRndNow =0;
int pressureRndPrevious =0;
int adjustOn = 1; // allows adjustment of barometer
// int test = 0; // test mode 0 off 1 is on

char status;
  double T,P,a;

//int h =0;
//int m = 0;
//int j = 0;
int stepcount = 0;
//int time = 0;
//int resetmins = 1;
//int secondNow = 0;
//int secondPrevious=0;
//int minuteNow = 0;
//int minutePrevious=0;
//int hourNow = 0;
//int hourPrevious=0;
int initial = 0;
int initial1 = 0;
int initial3 = 0;
//int sync30 = 3;//30sec sync on pin18
//int syncLED = 15;
//int manSync = 12;
//int adjustOn = 12;
//int syncStop = 0;
//int sync30Stop = 0;
int stepoffHour = 0;
int stepoffHourbkw = 0;
int stepoffMin = 0;
int stepoffMinbwd = 0;
//int stepoffRTCminfwd = 0;
//int stepoffRTCminbwd = 0;
//int stepoffRTChourfwd = 0;
//int stepoffRTChourbwd = 0;
//int settingreadPin = A3; //Pin for sensing analogue value from pot
//int settingVal = 0; // Analogue value 0-1023
int LCDstop = 0; // stops settings on LCD display refreshing until they change
int hourPulse = 3; //hour pulse from main Barometer Arduino
int adjustLock = 0; // turns off adjust lock
int hourcalc = 0;
float hourDiff = 0.50; // used to check if 3hour previous motor should be stepped.
float hourChange = 0.00; // the amount of 3 hour to step float value
int hourStep = 0; //the amount of 3 hour to step
int  hourStepdigit1 = 0; // gets the 1st digit from hourstep
int  hourStepdigit2 = 0; // gets the 2nd digit from hourstep
int stepTotal = 0; // tptal amount of steps for 3 hour motor
int  hourChangeNeg = 0;// if hour change is -ve this stores the value to chenge stepTotal later
float currentDisplay = 0.50; //current 3hour change reading
float hour0 = 1036.00; // you can set last 3 hours pressure here or leave at 0 and the
float hour1 = 1036.00; // readings will catch up over the next 4 hours
float hour2 = 1036.00;
float hour3 = 1036.00;
float hour4 = 1036.00;

//check readings https://www.meteoplug.com/cgi-bin/meteochart.cgi?draw=a3aeaaa1acbdf9f1fcfed4fedbc2c094c0d6d6d1d2c5edcebbfee9ffeff1fbf9
int sleep = 9;
int hourPulseOff = 0;
//int testinput = 17;
int testpulse = 0;
int hourPlus1min = 0;
int stepFwd1 = 14;
int manstepFwd1 = 0;
int maninchFwdBwd = A7;
int stepBwd1 = 15;
int manstepBwd1 = 0;
int hour3LowLED = 5;// Green low range LED
int hour3HighLED = 4;//Red high range LED
int ledStormy = 8;
int ledRain = 7;
int ledChange = 6;
int ledFair = 2;
int ledDry = 13;
int ledClear = 12;
int ledThreat = 17;
int ledNoChange = 16;

//Test
int n = 0;
int n1 =0;
int n2 =0;





void setup() {

  
  pinMode(ledStormy, OUTPUT);
  pinMode(ledRain, OUTPUT);
  pinMode(ledChange, OUTPUT);
  pinMode(ledFair, OUTPUT);
  pinMode(ledDry, OUTPUT);
  pinMode(ledClear, OUTPUT);
  pinMode(ledThreat, OUTPUT);
  pinMode(ledNoChange, OUTPUT);
  
   pinMode(stepFwd1, INPUT);
   pinMode(stepBwd1, INPUT);
 // pinMode(adjustOn, INPUT);
  pinMode(hourPulse, INPUT);
  pinMode(hour3LowLED, OUTPUT);
  pinMode(hour3HighLED, OUTPUT);
  pinMode(sleep, OUTPUT);
 
  

 // pinMode(settingreadPin, INPUT);
  // Set the maximum steps per second:
  stepper.setMaxSpeed(1000);


  
  lcd.begin(20,4);   // initialize the lcd for 20 chars 4 lines, turn on backlight
     lcd.backlight(); // backlight on not needed as controlled by 7 MAX2719
  lcd.setCursor(0,0); //Start at character 0 on line 0
  lcd.print("Barometer A988 3 Hr");  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
  lcd.setCursor(0,1); //Start at character 0 on line 0
  lcd.print("    Version 27"); //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 
  


  
  {
 // Wire.begin();
  Serial.begin(9600);
 
delay(2000);
lcd.setCursor(0,2); //Start at character 0 on line 0
  lcd.print("##### LED TEST #####"); //@@@@@@@@

}
//#############################################################
Serial.println("REBOOT v08");
//############################################################

  // Initialize the sensor (it is important to get calibration values stored on the device).

  if (pressure.begin())
    Serial.println("BMP180 init success");
  else
  {
    // Oops, something went wrong, this is usually a connection problem,
    // see the comments at the top of this sketch for the proper connections.

    Serial.println("BMP180 init fail\n\n");
    while(1); // Pause forever.
  }
// test = 1; // test set to 0 off 1 on
//LED Test
delay (2000);
digitalWrite(ledThreat, HIGH);
delay (500);
digitalWrite(ledThreat, LOW);

digitalWrite(ledNoChange, HIGH);
delay (500);
digitalWrite(ledNoChange, LOW);

digitalWrite(ledClear, HIGH);
delay (500);
digitalWrite(ledClear, LOW);

digitalWrite(ledStormy, HIGH);
delay (500);
digitalWrite(ledStormy, LOW);

digitalWrite(ledRain, HIGH);
delay (500);
digitalWrite(ledRain, LOW);

digitalWrite(ledChange, HIGH);
delay (500);
digitalWrite(ledChange, LOW);

digitalWrite(ledFair, HIGH);
delay (500);
digitalWrite(ledFair, LOW);

digitalWrite(ledDry, HIGH);
delay (500);
digitalWrite(ledDry, LOW);

digitalWrite(hour3HighLED, HIGH);
delay (500);
digitalWrite(hour3HighLED, LOW);

digitalWrite(hour3LowLED, HIGH);
delay (500);
digitalWrite(hour3LowLED, LOW);

 lcd.clear();
 
 getPressure ();// gets all pressure readings
 showLCD(); // load display to LCD
 getForecast(); //get forcast and set LEDs for weather
 
//disable motors on startup
digitalWrite(sleep, HIGH);
stepper.disableOutputs();

 


}







void loop() {
   

 

  

 
   hourPlus1min = (digitalRead(hourPulse));//checks for pulse at 1min past the hour from the barometer
  
    if (hourPlus1min == HIGH && hourPulseOff ==0 || initial1 ) 
  {
   digitalWrite(hour3LowLED, HIGH);
   digitalWrite(hour3HighLED, HIGH);
    initial1 =0;
    hourcalc++;
   
    if (hourcalc > 4)
    {
    hourcalc = 0;
   
    }
    //Serial.print("hourcalc ");// serial removed
    // Serial.println(hourcalc);// serial removed
  
       
    
   getPressure ();// gets all pressure readings
   getForecast(); //get forcast and set LEDs for weather
   showLCD(); // load display to LCD






  
   hourPulseOff = 1; //turns off 
  }
  else if (hourPlus1min == LOW)
  {
   hourPulseOff = 0;
   digitalWrite(hour3LowLED, LOW);
   digitalWrite(hour3HighLED, LOW);
  }
  adjustLock = 0; //hold on adjustment



// Step forward/back man~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  // step hours 1 hour per press
 manstepFwd1 = digitalRead(stepFwd1);
  

  
if( manstepFwd1 == HIGH && stepoffHour == 0 )
 {
  
    stepoffHour = 1;
    stephourmanFwd();
 
 }
   manstepFwd1 = digitalRead(stepFwd1);

if( manstepFwd1 == LOW )
   {
    stepoffHour = 0;
   }


 
 
 // step hours 1 hour per press
 manstepBwd1 = digitalRead(stepBwd1);

 if( manstepBwd1 == HIGH && stepoffHour == 0 )
 {
  
    stepoffHour = 1;
    stephourmanBwd();
 
 }
   manstepBwd1 = digitalRead(stepBwd1);

 
 if( manstepBwd1 == LOW)
 {
 stepoffHour = 0;
 }
 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 //Inch 3hr forward/backwards
maninchFwdBwd= analogRead(A7);


if (maninchFwdBwd >800 )
{
//  Serial.print(" maninchFwdBwd= ");// serial removed
 // Serial.println(maninchFwdBwd);// serial removed
         
  maninchFwd();
   
}

 else if (maninchFwdBwd <200)
 {
   
//  Serial.print(" maninchFwdBwd= ");// serial removed
//  Serial.println(maninchFwdBwd);// serial removed
  maninchBwd();
  
 }

    //##############################################################################

//step 3 hour motor
if (hourChange > 0 && hourChange < 20) // 3 hour motor will not step if diff > 40
     {
     stephourFwd();
     
       //  Serial.print("Step 3 hour Forward ");// serial removed
        // Serial.println(hourChange);// serial removed
         hourChange = 0;
     }
     else if(hourChange < 0 && hourChange > -20)
     
     {
       
       
      stephourBwd();
     // Serial.print("Step 3 Hour Backward ");// serial removed
     //  Serial.println(hourChange);// serial removed
     hourChange = 0;
     
      
     }
    
         
  
//##############################################################################
    
  
 //show 3 hour pressure scale hi/low LEDs

if(hourDiff > 9 || hourDiff < -9) // if 3 hour pressure is outside of extended range both hi and low range leds light
{
digitalWrite( hour3HighLED, HIGH);
  digitalWrite( hour3LowLED, HIGH);
}
else if(hourDiff >= 4.80)
 {
  digitalWrite( hour3HighLED, HIGH);
  digitalWrite( hour3LowLED, LOW);
 }

 else if (hourDiff <= -4.80)
 {
  digitalWrite( hour3LowLED, HIGH);
  digitalWrite( hour3HighLED, LOW);
 }

 else if ( hourDiff <4.80 && hourDiff >-4.80 )
 {
 digitalWrite( hour3LowLED, LOW);
 digitalWrite( hour3HighLED, LOW);
 }
  


 }


    
  





//##################################################################################


// set Hour Motor backward 1 hour per press ##################################################################################
void setHoursbwd()
{
  // digitalWrite(sleep, LOW);
//  stepper.enableOutputs();

 // step hours 1 hour per press
   if( digitalRead(adjustOn) == HIGH && stepoffHourbkw == 0 )
   {
   // Serial.println("Step 3hr Backward Man");
    stepoffHourbkw = 1;
    stephourmanBwd();
   }
//   stepper.disableOutputs();
//   digitalWrite(sleep, HIGH);

if( digitalRead(adjustOn) == LOW )
   {
    stepoffHourbkw = 0;
   
   }
//  End step hours 1 hour per press


}
//##################################################################################




// step hours slow forward const press ##################################################################################


void  maninchFwd()
{
  stepper.enableOutputs();
  digitalWrite(sleep, LOW);
   if( digitalRead(adjustOn) == HIGH )
   {
  //  Serial.println("Step 3hr Inch Forward Man");// serial removed
   stepper.setCurrentPosition(0);
 
  // Run the motor forward at 500 steps/second until the motor reaches 8 steps (1 revolution):
  while (stepper.currentPosition() != 1) {  //was 52     52x60 =3120
    stepper.setSpeed(10);//was 10
    stepper.runSpeed();
    
  }
   
   }
   digitalWrite(sleep, HIGH);
stepper.disableOutputs();
}


//##################################################################################

// step hours slow backward const press ##################################################################################


void  maninchBwd()
{
  stepper.enableOutputs(); 
  digitalWrite(sleep, LOW);
   if( digitalRead(adjustOn) == HIGH )
   {
  // Serial.println("Step 3hr Inch backward Man");// serial removed
   stepper.setCurrentPosition(0);
 
  // Run the motor forward at 500 steps/second until the motor reaches 8 steps (1 revolution):
  while (stepper.currentPosition() != -1) {  //was 52     52x60 =3120
    stepper.setSpeed(-10);//was-10
    stepper.runSpeed();
    
  } 
   }
   digitalWrite(sleep, HIGH);
stepper.disableOutputs();
}


//##################################################################################


 //Hour Motor #####################################################################################################
void stephourFwd() // steps hour hand forward 1 hour
{
   stepper.enableOutputs();
 // Serial.println("Step 3 hrs forward auto");// serial removed
   digitalWrite(sleep, LOW);
  stepper.setCurrentPosition(0);
 
  // Run the motor forward at 500 steps/second until the motor reaches 4096 steps (1 revolution):
  while (stepper.currentPosition() != hourChange*160) {  //hourDiff gives the nuber of steps to take
     stepper.setSpeed(400);
     stepper.runSpeed();
  } 
  digitalWrite(sleep, HIGH);
    stepper.disableOutputs(); 
   }
//###############################################################################################################



//Hour Motor #####################################################################################################
void stephourBwd() // steps hour hand backward 1 hour
{
    stepper.enableOutputs();
  //Serial.println("Step 3hrs backward auto");// serial removed
  digitalWrite(sleep, LOW);
 stepper.setCurrentPosition(0);
while ( stepper.currentPosition() != hourChange*160) {
     stepper.setSpeed(-400);
     stepper.runSpeed();
    
}
digitalWrite(sleep, HIGH);
  stepper.disableOutputs();
 }
//###############################################################################################################


//Hour Motor Man Step forward#####################################################################################################
void stephourmanFwd() // steps hour hand forward 1 hour
{
    stepper.enableOutputs();
  digitalWrite(sleep, LOW);
  //Serial.println("Step 3hr forward man");// serial removed
   stepper.setCurrentPosition(0);
 
  // Run the motor forward at 500 steps/second until the motor reaches 4096 steps (1 revolution):
  while ( stepper.currentPosition() != 160) {  
  
     stepper.setSpeed(400);
     stepper.runSpeed();
  } 
    digitalWrite(sleep, HIGH);
     stepper.disableOutputs();
   }
//###############################################################################################################



//Hour Motor Man Step back ward #####################################################################################################
void stephourmanBwd() // steps hour hand backward 1 hour
{
    stepper.enableOutputs();
   digitalWrite(sleep, LOW);
 // Serial.println("Step 3hr backward man");// serial removed
 stepper.setCurrentPosition(0);
while ( stepper.currentPosition() != -160) {

     stepper.setSpeed(-400);
     stepper.runSpeed();
    
}
digitalWrite(sleep, HIGH);
 stepper.disableOutputs();
 }
//###############################################################################################################



void getPressure ()//get all pressure readings checked every 10 mins eg 0 10 20 etc
{
  
if (checkStop == 0)
{
  // If you want sea-level-compensated pressure, as used in weather reports,
  // you will need to know the altitude at which your measurements are taken.
  // We're using a constant called ALTITUDE in this sketch:
  
 // Serial.println();
 // Serial.print("provided altitude: ");
 // Serial.print(ALTITUDE,0);
//  Serial.print(" meters, ");
 // Serial.print(ALTITUDE*3.28084,0);
//  Serial.println(" feet");
  
  // If you want to measure altitude, and not pressure, you will instead need
  // to provide a known baseline pressure. This is shown at the end of the sketch.

  // You must first get a temperature measurement to perform a pressure reading.
  
  // Start a temperature measurement:
  // If request is successful, the number of ms to wait is returned.
  // If request is unsuccessful, 0 is returned.

  status = pressure.startTemperature();
  if (status != 0)
  {
    // Wait for the measurement to complete:
    delay(status);

    // Retrieve the completed temperature measurement:
    // Note that the measurement is stored in the variable T.
    // Function returns 1 if successful, 0 if failure.

    status = pressure.getTemperature(T);
    if (status != 0)
    {
      // Print out the measurement:
    //  Serial.print("temperature: ");
    //  Serial.print(T,2);
   //   Serial.print(" deg C, ");
    //  Serial.print((9.0/5.0)*T+32.0,2);
   //   Serial.println(" deg F");
      
      // Start a pressure measurement:
      // The parameter is the oversampling setting, from 0 to 3 (highest res, longest wait).
      // If request is successful, the number of ms to wait is returned.
      // If request is unsuccessful, 0 is returned.

      status = pressure.startPressure(3);
      if (status != 0)
      {
        // Wait for the measurement to complete:
        delay(status);

        // Retrieve the completed pressure measurement:
        // Note that the measurement is stored in the variable P.
        // Note also that the function requires the previous temperature measurement (T).
        // (If temperature is stable, you can do one temperature measurement for a number of pressure measurements.)
        // Function returns 1 if successful, 0 if failure.

        status = pressure.getPressure(P,T);
        if (status != 0)
        {
          // Print out the measurement:
       //   Serial.print("absolute pressure: ");
       //   Serial.print(P,2);
      //    Serial.print(" mb, ");
      //    Serial.print(P*0.0295333727,2);
      //    Serial.println(" inHg");

          // The pressure sensor returns abolute pressure, which varies with altitude.
          // To remove the effects of altitude, use the sealevel function and your current altitude.
          // This number is commonly used in weather reports.
          // Parameters: P = absolute pressure in mb, ALTITUDE = current altitude in m.
          // Result: p0 = sea-level compensated pressure in mb

          seaPressure = pressure.sealevel(P,ALTITUDE); // we're at 160 meters (Kenley, Surrey UK)
         // serial removed
         /*
          Serial.print("relative (sea-level) pressure: ");
          Serial.print(seaPressure,2);
          Serial.print(" mb, ");
          Serial.print(seaPressure*0.0295333727,2);
          Serial.println(" inHg");

         */ 

          

          // On the other hand, if you want to determine your altitude from the pressure reading,
          // use the altitude function along with a baseline pressure (sea-level or other).
          // Parameters: P = absolute pressure in mb, p0 = baseline pressure in mb.
          // Result: a = altitude in m.

          a = pressure.altitude(P,seaPressure);
     //    Serial.print("computed altitude: ");
   //       Serial.print(a,0);
    //      Serial.print(" meters, ");
    //      Serial.print(a*3.28084,0);
    //      Serial.println(" feet");
        }
        else Serial.println("error retrieving pressure measurement\n");
      }
      else Serial.println("error starting pressure measurement\n");
    }
    else Serial.println("error retrieving temperature measurement\n");
  }
  else Serial.println("error starting temperature measurement\n");
}


//Serial.print("hourscalc ");
 // Serial.println(hourcalc);


if (hourcalc == 0)
{
  hour0 = seaPressure;//was rnd sea pressure
  currentDisplay = hourDiff; // the last display reading becomes the old reading called currentDisplay
  hourDiff = hour0 - hour3; // this is the air pressure difference from now to the reading 3 hours ago and wil be displayed onthe 3 hour dial
  
 
  calcCurrentDisp (); // calculates 3 hour Air pressure display
 
}

else if (hourcalc == 1)
{
  hour1 = seaPressure;
  currentDisplay = hourDiff;
    hourDiff = hour1 - hour4;
  

     calcCurrentDisp ();
    
}


else if (hourcalc == 2 )
{
  hour2 = seaPressure;
  currentDisplay = hourDiff;
hourDiff = hour2 - hour0;


 calcCurrentDisp ();
     
}

else if (hourcalc == 3 )
{
  hour3 = seaPressure;
  currentDisplay = hourDiff;
  hourDiff = hour3 - hour1;
 

   calcCurrentDisp ();
    
}

else if (hourcalc == 4 )
{
  hour4 = seaPressure;
  currentDisplay = hourDiff;
   hourDiff = hour4 - hour2;

 

    calcCurrentDisp ();
    
}
/*
//Moved to Loop
//show 3 hour pressure scale hi/low LEDs

if(hourDiff > 9 || hourDiff < -9) // if 3 hour pressure is outside of extended range both hi and low range leds light
{
digitalWrite( hour3HighLED, HIGH);
  digitalWrite( hour3LowLED, HIGH);
}
else if(hourDiff >= 4.80)
 {
  digitalWrite( hour3HighLED, HIGH);
  digitalWrite( hour3LowLED, LOW);
 }

 else if (hourDiff <= -4.80)
 {
  digitalWrite( hour3LowLED, HIGH);
  digitalWrite( hour3HighLED, LOW);
 }

 else if ( hourDiff <4.80 && hourDiff >-4.80 )
 {
 digitalWrite( hour3LowLED, LOW);
 digitalWrite( hour3HighLED, LOW);
 }

 
*/
// Serial.print("currentDisplay (old) ");// serial removed
 // Serial.println(currentDisplay);// serial removed

//  Serial.print("3 hour display to show ");// serial removed
// Serial.println(hourDiff);// serial removed
//Serial.print("RND seaPressure ");
//Serial.println(round(seaPressure));

//get pressure change and show change over 1 hour on LCD bottom row
  pressureNow = seaPressure ;

  if ( pressureNow != pressurePrevious || initial )
  {
     initial = 0;
     pressureDiff = pressureNow - pressurePrevious;

     //Print pressure and diff on LCD
     lcd.setCursor(0,3);
    
    if (pressurePrevious == 0.00)
    {
      pressurePrevious =  pressureNow ;// shows previous pressure at startup
    }
     
     
     if(pressurePrevious<1000)
    {
      lcd.print(0);
    }
    lcd.print(pressurePrevious);// shows previous pressure until 1hPa change

    lcd.print("hPa  ");

   // pressurePrevious =  pressureNow ;
    
     lcd.setCursor(12,3);
     lcd.print("        ");//blank section
     lcd.setCursor(12,3);
     lcd.print(pressureDiff);

     // show rounded pressure reading on display updayes every hour
   
     lcd.setCursor(0,2);
      lcd.print("           ");
    // show rounded pressure on lcd
    lcd.setCursor(0,2);
    if(pressureNow<1000)
    {
      lcd.print(0);
    }
   lcd.print(round(pressureNow));
  


  }
  pressureRndPrevious =  pressureRndNow ;
  pressurePrevious =  pressureNow ;//resets pressure change


//#################################################################################

 
  }


  //####################################################################
// show forecast on LEDs

/*
 Predicting the Weather With the Barometer
More specifically, a barometer with readings in hPa can be interpreted in this manner:

If the reading is over 1022 hPa 

Rising or steady pressure means continued fair weather.
Slowly falling pressure means fair weather.
Rapidly falling pressure means cloudy and warmer conditions.


If it falls between 1009–1022 hPa 

Rising or steady pressure means present conditions will continue.
Slowly falling pressure means little change in the weather.
Rapidly falling pressure means that rain is likely, or snow if it is cold enough.


If the reading is under (1009 hPa

Rising or steady pressure indicates clearing and cooler weather.
Slowly falling pressure indicates rain
Rapidly falling pressure indicates a storm is coming.



Rising or Falling slowly

Pressure change of 0.1 to 1 mb in the preceding three hours

Rising or Falling

Pressure change of 1 to 3 mb in the preceding three hours

Rising or Falling quickly

Pressure change of 3 to 6 mb in the preceding three hours

Rising or Falling very rapidly

Pressure change of more than 6.0 mb in the preceding three hours
 */

void getForecast()
{

 //reading is under (1009 hPa
 //Rising or steady pressure indicates clearing and cooler weather
 
  if(seaPressure <1009.00 && hourDiff >=0 )
  {
    ClearforecastLED();// clear all forecast LEDs before changing
   
    digitalWrite( ledChange, HIGH);
    digitalWrite( ledClear, HIGH);

     lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Chg Clearing");

    
    
  }


   //reading is under (1009 hPa
   //Slowly falling pressure indicates rain

  else if(seaPressure <1009.00 && hourDiff <0 && hourDiff >=-1.5 )
   {
    
    ClearforecastLED();
    
    digitalWrite( ledRain, HIGH);
    digitalWrite( ledThreat, HIGH);
    
     lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Rain Threat");
    
   }


    //reading is under (1009 hPa
   //Rapidly falling pressure indicates a storm is coming. 
  
  else if(seaPressure <1009.00 && hourDiff <-1.5 )
   {
  ClearforecastLED();
  digitalWrite( ledStormy, HIGH);
  digitalWrite( ledThreat, HIGH);

   lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Storm Threat");
    
   }
  
 
  
  //1009–1022 hPa
  //Rising or steady pressure means present conditions will continue.
  //Slowly falling pressure means little change in the weather.
  
  else if(seaPressure >= 1009.00 && seaPressure <= 1022.00 && hourDiff >=-1.5 && hourDiff <=1.5 )
   {
  ClearforecastLED();
  digitalWrite( ledNoChange, HIGH);
  digitalWrite( ledFair, HIGH);

   lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Fair No Chge");
    
   }

//1009–1022 hPa
  //Rising rapidly
  //Clearing
  
  else if(seaPressure >= 1009.00 && seaPressure <= 1022.00 && hourDiff >1.5  )
   {
  ClearforecastLED();
 digitalWrite( ledClear, HIGH);
  digitalWrite( ledFair, HIGH);

   lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Fair Clear");
    
   }



   


 //1009–1022 hPa
 //Rapidly falling pressure means that rain is likely, or snow if it is cold enough.

  else if(seaPressure >= 1009.00 && seaPressure <= 1022.00 && hourDiff <-1.5  )
   { 
    ClearforecastLED();
    digitalWrite( ledRain, HIGH);
    digitalWrite( ledThreat, HIGH);

     lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Rain Threat");
    
    
   }
   
     
 // over 1022 hPa
 //Rising or steady pressure means dry weather.

   else if(seaPressure > 1022.00 && hourDiff >= 0 ) 
   {
    ClearforecastLED();
    digitalWrite( ledClear, HIGH);
    digitalWrite( ledDry, HIGH);

      lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Dry Clearing");
    
   }

 // over 1022 hPa
 //Slowly falling pressure means fair weather.
 
   else if(seaPressure > 1022.00 && hourDiff < 0 && hourDiff >= -1.5  ) 
   {
    ClearforecastLED();
    digitalWrite( ledNoChange, HIGH);
    digitalWrite( ledFair, HIGH);

     lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Fair No Chge");
    
   }
   
   // over 1022 hPa
   // Rapidly falling pressure means change
   
   else if(seaPressure > 1022.00 && hourDiff < -1.5  )
   {
    ClearforecastLED();
     digitalWrite( ledChange, HIGH);
     digitalWrite( ledThreat, HIGH);

      lcd.setCursor(8,2);
    lcd.print("            ");
    lcd.setCursor(8,2);
     lcd.print("Chge Threat");
    
   }
      



  
}

void ClearforecastLED()
{
  digitalWrite( ledNoChange, LOW);
  digitalWrite( ledStormy, LOW);
    digitalWrite( ledRain, LOW);
      digitalWrite( ledChange, LOW);
        digitalWrite( ledFair, LOW);
          digitalWrite( ledDry, LOW);
            digitalWrite( ledClear, LOW);
              digitalWrite( ledThreat, LOW);  

  
}






  //######################################################################


   void calcCurrentDisp () // calcs currentdisplay (shows change on 6hr scale)
   {
 // common calc


  
 // hourDiff is a floating point number and is the diff from the pressure now to the pressure 3 hours ago
 // hourDiff will be the number displayed on the 3hour dial
 // to change tohe dial the number of steps to change the motor - or + will need to be calculated
 // first we need to round the hourDiff to the nearest 0.5 hPa
 // -ve sign is removed and remembered as hourChangeNeg =1
 
 
 if( hourDiff < 0.00)//Brett 27/01/19
 {
  hourChangeNeg = 1; // remembers hourChange is -ve

   hourDiff = -1.00 * hourDiff ; // make hourChange +ve
  
 }
 else  hourChangeNeg = 0;

 //Serial.print("hourChangeNeg ");// serial removed
 // Serial.println(hourChangeNeg);// serial removed



  if( hourDiff >= 0.30 ) // rounded to 0 so are steps required so caluculate how many. If not true jump to 1946  #########################################################################################################################
{



// hourDiff is times by 10 then rounded to get a whole number
// eg 4.79 x10 is 47.9 then rouneded = 47
// hourDiff now becomes hourStep

hourStep = round(hourDiff*10); // converts floating point hour change to whole number 10 x bigger then rounds to remove remainder
//Serial.print(" RND hourStep x 10 ");// serial removed
//  Serial.println(hourStep);// serial removed

  
//Using the MODULO (%) function the 1st digit is seperated out and is called hourStepdigit1
//eg the 47 from above now becomes 7 (remember this is really 0.7)
 
 if(hourDiff >0.09)  //if hourDiff not >0.09 eg 0.05 not there is no number 1st right of the decimal point 1s
{

hourStepdigit1 = (hourStep / 1U) % 10; 
  
}

else
{
  hourStepdigit1 = 0;
} 
  
 // Serial.print(" hourStepdigit1 ");// serial removed
 // Serial.println(hourStepdigit1);// serial removed


  // As 7 is really 0.7 it needs to be rounded up or down to 0.5 as the motor only steps in 0.5 steps
  // The number is rouned up or down as follows
  // if hourStep > 7 rounded up to next whole number so motor is stepped 2 steps (each step is half)
  // if hourStep <= 7 && > = 3 is rounded up/down to 0.5 or 1 step
  // if hourStep < 3 rounded down to 0 so  0 steps

  if( hourStepdigit1 > 7)
  {
    hourStepdigit1 = 2;// step 2 x to round up
  }

  else if(hourStepdigit1 <= 7 && hourStepdigit1 >= 3)
  {
     hourStepdigit1 = 1;// step 1 x to round up or down to 0.5
  }

  else if( hourStepdigit1 <3)
  {
     hourStepdigit1 = 0;// step 0 x to round down
  }

 //  Serial.print(" hourStepdigit1 converted to steps= ");// serial removed
 // Serial.println(hourStepdigit1);// serial removed

  

  //Using the MODULO (%) function the 2nd digit is seperated out and is called hourStepdigit2
//eg the 47 from above now becomes 4 (remember this is a whole number)
// calc steps for 2 digit of hourStep


if(hourDiff >0.99)  //if hourDiff not a whole number eg 0.78 not there is no number 2nd right of the decimal point 10s
{

 hourStepdigit2 = (hourStep / 10U) % 10; // nuber of steps to take note double this as 3 hour display now has 0.5 hPa resolution
  
}

else
{
  hourStepdigit2 = 0;
}



//Now the 2 numbers from above are added together as they are now steps
//The motor takes 2 steps for every unit.
//This has already been calculated for hourStepdigit1 0 = 0 steps, 0.5 = 1 step and > 0.7 = 2 steps
//hourStepdigit is a whole number so each step has to be times by 2
 
  // total steps to take
  stepTotal = (hourStepdigit2 + hourStepdigit2 ) +  hourStepdigit1;
//Serial.print(" stepTotal without -ve= ");// serial removed
//  Serial.println(stepTotal);// serial removed

  // stepTotal is now the number of steps to drive the 3 hour motor to it's correct position
  // we now have to add the - sign back in if hourChane was less than 0 above

   if (hourChangeNeg == 1)// if hourDiff was a -ve value make it -ve again
   {
    stepTotal = -1 * stepTotal;
    hourDiff = -1 * hourDiff;
   }

 

//###################################################################################################################################################################################

hourDiff = stepTotal*0.5;

} //if no steps required jump to here

 else if (hourDiff < 0.30)
 {
  stepTotal =0;
   hourDiff = 0.00;
 }

lcd.setCursor(14,1);
   lcd.print("      ");
    lcd.setCursor(14,1);
   lcd.print("D");
   lcd.print(hourDiff);



//Serial.print(" hourDiff now rnd to 0.5 ");// serial removed
//  Serial.println(hourDiff);// serial removed

 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
  
  
  
  if (hourDiff <= 0.00 && currentDisplay >= 0.00 )
  {
  hourChange = hourDiff - currentDisplay; 
  
  }
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   else if (hourDiff <= 0.00 && currentDisplay <= 0.00 )
 {
  if( hourDiff > currentDisplay)
  {
   hourChange = (-1 * currentDisplay) + (hourDiff) ; 
  }
  else if ( hourDiff < currentDisplay)
  {
  hourChange = (-1 * currentDisplay ) + hourDiff; 
 }

 else if (hourDiff >= 0.00 && currentDisplay <= 0.00 )
 {
   hourChange = hourDiff + (-1 * currentDisplay); 
 }
 
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  
 else if (hourDiff >= 0.00 && currentDisplay >= 0.00 )
 {
   hourChange = hourDiff - currentDisplay; 
 }
 

else if (hourDiff >= 0.00 && currentDisplay <= 0.00 )
 {
   hourChange = hourDiff + (-1 * currentDisplay); 
 }

   //  if(hourDiff == 0.00)
  //{
    // if there is no difference between pressure now and pressure 3 hours ago then hour diff is the old value (current display)
    
  // hourDiff = currentDisplay; // prevents hourDiff being 0
 // }

 //Serial.print("hourChange Line 1144 ");// serial removed
 // Serial.println(hourChange);// serial removed

  hourChange = hourChange * 2;//0.5hPa per step

// serial removed
/*
Serial.print("hourChange x2 ");
  Serial.println(hourChange);




   Serial.print(" stepTotal= ");
  Serial.println(stepTotal);

  Serial.print(" Previous 3 hr displayed (currentDisplay) ");
  Serial.println(currentDisplay);

*/

//#########################################################################################################################

  
 
 
  // Serial.print("hourDiff ");
 // Serial.println(hourDiff);
 // Serial.print("hourchange - correction required to 3 hour display ");// serial removed
 // Serial.println(hourChange);// serial removed

   lcd.setCursor(6,1);
   lcd.print("        ");
    lcd.setCursor(6,1);
   lcd.print("St");
   lcd.print(hourChange);

  

   }


void showLCD()
{
  // lcd.setCursor(0,1);
   // lcd.print("  ");
   // lcd.setCursor(0,1);
   // lcd.print("H");
  //  lcd.print(hourcalc);

   lcd.setCursor(0,1);
    lcd.print("      ");
    lcd.setCursor(0,1);
    
    lcd.print(currentDisplay);
    //lcd.print(" ");
 //  lcd.print(hourDiff);
  
   
  
   


  //print hour stores every hour
  // serial removed
  /*
  Serial.print("hour0 ");
  Serial.println(hour0);

  Serial.print("hour1 ");
  Serial.println(hour1);

  Serial.print("hour2 ");
  Serial.println(hour2);

  Serial.print("hour3 ");
  Serial.println(hour3);

  Serial.print("hour4 ");
  Serial.println(hour4);
*/
  //print hour stores every hour on LCD
  
 lcd.setCursor(0,0);
 lcd.print("                    ");
 lcd.setCursor(0,0);
 
 if(hourcalc == 0)
 {
   lcd.print("A");
   lcd.print(hour0);
   lcd.print(" ");
   

  

   lcd.print("D");
   lcd.print(hour3);

   
 }

 else if(hourcalc == 1)
 {
   lcd.print("B");
   lcd.print(hour1);
   lcd.print(" ");
  

   lcd.print("E");
   lcd.print(hour4);
 }

 else if(hourcalc == 2)
 {
   lcd.print("C");
   lcd.print(hour2);
   lcd.print(" ");
   

   lcd.print("A");
   lcd.print(hour0);
 }

  else if(hourcalc == 3)
 {

   lcd.print("D");
   lcd.print(hour3);
   lcd.print(" ");
  
   lcd.print("B");
   lcd.print(hour1);
 }

  else if(hourcalc == 4)
 {

   lcd.print("E");
   lcd.print(hour4);
   lcd.print(" ");
   

   lcd.print("C");
   lcd.print(hour2);
 }
  
  
  
  
  
  
  }
